/**
 * MAC440  - Sistemas de Objectos Distribudos 
 * Aluno   - Charlie Yukio Nakagawa - 2236341
 *         - Gustavo Castilhos      - 1142713
 * Projeto - Autenticacao com Interceptadores no JDK 1.4
 **/
package autentica;

import java.io.*;
import java.util.*;
import javax.security.auth.login.*;
import javax.security.auth.*;
import javax.security.auth.callback.*;

/**
 * Classe AutenticaAcn
 * Faz a autenticacao
 **/
public class AutenticaAcn {
  public boolean autentica(String username, String password) {
    LoginContext lc = null;
    try {
      lc = new LoginContext("Autentica", new AutenticaCallbackHandler(username, password));
    } 
    catch (LoginException le) {
      System.err.println("Cannot create LoginContext. " + le.getMessage());
      return false;
    }
    catch (SecurityException se) {
      System.err.println("Cannot create LoginContext. " + se.getMessage());
      return false;
    } 
    /**
     * Tenta logar-se 3 vezes
     **/
    int i;
    for (i = 0; i < 3; i++) {
      try {
        lc.login();
        break;
      } 
      catch (LoginException le) {
        System.err.println("Autenticacao falhou:");
        System.err.println("  " + le.getMessage());
        try {
          Thread.currentThread().sleep(3000);
        }
        catch (Exception e) {
        } 
      }
    }
    /**
     * Se falhou as 3 vezes
     **/
    if (i == 3) {
      System.out.println("Perdao...");
      return false;
    }
    System.out.println("Autenticado com sucesso!");
    return true;
  }
}
/**
 * Classe AutenticaCallbackHandler 
 * Coloca o usuario e a senha
 */
class AutenticaCallbackHandler implements CallbackHandler {
  private String username;
  private String password;
    
  public AutenticaCallbackHandler(String username, String password) {
    this.username = username;
    this.password = password;
  }  
    
  public void handle(Callback[] callbacks)
    throws IOException, UnsupportedCallbackException {
      
  	for (int i = 0; i < callbacks.length; i++) {
	    if (callbacks[i] instanceof TextOutputCallback) {
      
    		TextOutputCallback toc = (TextOutputCallback)callbacks[i];
    		switch (toc.getMessageType()) {
    		case TextOutputCallback.INFORMATION:
     		    System.out.println(toc.getMessage());
     		    break;
     		case TextOutputCallback.ERROR:
     		    System.out.println("ERROR: " + toc.getMessage());
     		    break;
     		case TextOutputCallback.WARNING:
     		    System.out.println("WARNING: " + toc.getMessage());
     		    break;
     		default:
     		    throw new IOException("Unsupported message type: " +
     					toc.getMessageType());
     		}
      }
      else 
        if (callbacks[i] instanceof NameCallback) {
          /**
           * Nome do usuario
           **/
          NameCallback nc = (NameCallback)callbacks[i];
          nc.setName(username);
        } 
        else 
          if (callbacks[i] instanceof PasswordCallback) {
            /**
             * Senha do usuario
             **/
            PasswordCallback pc = (PasswordCallback)callbacks[i];
            pc.setPassword(password.toCharArray());
          } 
          else {
            throw new UnsupportedCallbackException (callbacks[i], "Unrecognized Callback");
 	        }
  	 }
  }
}