/**
 * MAC440  - Sistemas de Objectos Distribudos 
 * Aluno   - Charlie Yukio Nakagawa - 2236341
 *         - Gustavo Castilhos      - 1142713
 * Projeto - Autenticacao com Interceptadores no JDK 1.4
 **/
package interceptor;
import org.omg.CORBA.*;
import org.omg.PortableInterceptor.*;
import java.util.*;
import java.io.*;
import java.util.StringTokenizer;
import org.omg.PortableInterceptor.ForwardRequest;
import org.omg.IOP.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import javax.security.auth.login.*;
import javax.security.auth.*;
import javax.security.auth.callback.*;
import autentica.*;

/**
 * ServerLogInterceptor
 * Classe que faz as interceptacoes do lado do servidor
 **/
public class ServerLogInterceptor extends org.omg.CORBA.LocalObject
                                  implements ServerRequestInterceptor {
  private Calendar date;
  private Hashtable tableTable;
  private PrintStream logStream;
  
  /** 
   * constructor 
   **/
  public ServerLogInterceptor() {
    date = Calendar.getInstance();
    tableTable = new Hashtable();
    logStream = System.out;
  }
  /**
   * Delvolve o nome
   **/
  public String name() {
    return "ServerLogInterceptor";
  }
  /**
   * receive_request
   * Recebe o requeste do cliente
   **/  
  public void receive_request(ServerRequestInfo ri) throws ForwardRequest {
    String [] usrpwd = new String[2];
    try {
      try {
	      log("receive_request: " + ri.request_id());
	      StringTokenizer st = new StringTokenizer(new String(ri.get_request_service_context(77).context_data));
	      for (int i = 0;st.hasMoreTokens();++i) {
	        usrpwd[i] = st.nextToken().toString();
	      }
	      log("** " + usrpwd[0]);
	    }
	    catch (Exception e) {
	      log("**2 " + e.getMessage());
      }
    }
    catch (IOException io) {
      System.out.println(io.getMessage());
    }
    /**
     * Aqui vai a autenticao. A menos que ela jogue uma execeo, deve-se jogar
     * explicitamente a exceo ForwardRequest
     **/
     AutenticaAcn sa = new AutenticaAcn();
     boolean ok = sa.autentica(usrpwd[0], usrpwd[1]);
     if (!ok) {    
       throw new ForwardRequest();
     }
  }
  /**
   * receive_request
   * Recebe o requeste do cliente
   **/  
  public void send_reply(ServerRequestInfo ri) {
    try {
      log("send_reply:" + ri.reply_status());
    }
    catch (IOException io) {
    }
    ri.add_reply_service_context(new ServiceContext(79, (new String("Autenticado").getBytes())), true);
  }
  /**
   * send_exception
   * Envia uma excecao ao cliente
   **/  
  public void send_exception(ServerRequestInfo ri) {
    ri.add_reply_service_context(new ServiceContext(78, (new String("No autenticado").getBytes())), true);
    try {
      log("send_exception");
      
    }
    catch (IOException io) {
    }
  }
  /**
   * receive_request_service_contexts
   * Recebe informacoes do contexto
   **/  
  public void receive_request_service_contexts(ServerRequestInfo ri) throws ForwardRequest {
    try {
      Calendar cal = new GregorianCalendar();
      Date data = cal.getTime();
      DateFormat dataFormatada = new SimpleDateFormat("dd 'de' MMMMM 'de' yyyy, hh:mm:ss");
      log("** Log time: " + dataFormatada.format(data));
      log("Id: " + ri.request_id() + "\nreceive_request_service_contexts");    
    }
    catch (IOException io) {
    }
  }
  /**
   * send_other
   * Envia outras informacoes
   **/  
  public void send_other(ServerRequestInfo ri) throws ForwardRequest {
    try {
      log("send_other");    
    }
    catch (IOException io) {
    }
  }  
  
  public void destroy() {
  }
  /**
   * log
   * Grava em arquivo o log de transacoes
   **/    
  private void log(String logstr) throws IOException {
    File f = new File("server_interceptor.log");
    FileOutputStream fos = new FileOutputStream(f, true);
    fos.write((logstr + "\n").getBytes());
    fos.close();
  }
}